package io.accumulatenetwork.sdk.generated.protocol;

/**
    GENERATED BY go run ./tools/cmd/gen-api. DO NOT EDIT.
**/

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;
import io.accumulatenetwork.sdk.generated.managed.Receipt;
import io.accumulatenetwork.sdk.protocol.Signature;
import io.accumulatenetwork.sdk.protocol.Url;
import io.accumulatenetwork.sdk.support.Marshaller;
import io.accumulatenetwork.sdk.support.serializers.HexDeserializer;
import io.accumulatenetwork.sdk.support.serializers.HexSerializer;
// UnionType: SignatureType
// UnionValue: Receipt

@JsonIgnoreProperties(ignoreUnknown = true)
@JsonTypeName("ReceiptSignature")
@JsonInclude(JsonInclude.Include.NON_NULL)
public class ReceiptSignature implements Signature {
	public final SignatureType type = SignatureType.RECEIPT;
	private Url sourceNetwork;
	private Receipt proof;
	private byte[] transactionHash;

    //
	public Url getSourceNetwork() {
	    return sourceNetwork;
	}
	public void setSourceNetwork(final Url value) {
	    this.sourceNetwork = value;
	}

	public ReceiptSignature sourceNetwork(final Url value) {
	    setSourceNetwork(value);
	    return this;
	}
	public ReceiptSignature sourceNetwork(final String value) {
	    setSourceNetwork(Url.toAccURL(value));
	    return this;
	}
	public Receipt getProof() {
	    return proof;
	}
	public void setProof(final Receipt value) {
	    this.proof = value;
	}

	public ReceiptSignature proof(final Receipt value) {
	    setProof(value);
	    return this;
	}
	@JsonDeserialize(using = HexDeserializer.class)
	public byte[] getTransactionHash() {
	    return transactionHash;
	}
	@JsonSerialize(using = HexSerializer.class)
	public void setTransactionHash(final byte[] value) {
	    this.transactionHash = value;
	}

	public ReceiptSignature transactionHash(final byte[] value) {
	    setTransactionHash(value);
	    return this;
	}
	public ReceiptSignature transactionHash(final String value) {
		try {
			setTransactionHash(io.accumulatenetwork.sdk.commons.codec.binary.Hex.decodeHex(value));
		} catch (io.accumulatenetwork.sdk.commons.codec.DecoderException e) {
			throw new RuntimeException(e);
		}
	    return this;
	}
    public byte[] marshalBinary() {
        final var marshaller = new Marshaller();
        marshaller.writeValue(1, type);
        if (!(this.sourceNetwork == null)) {
            marshaller.writeUrl(2, this.sourceNetwork);
        }
        if (!(this.proof == null)) {
            marshaller.writeValue(3, proof);
        }
        if (!(this.transactionHash == null || this.transactionHash.length == 0)) {
            marshaller.writeHash(4, this.transactionHash);
        }
        return marshaller.array();
    }
}
